<script lang="ts">
import Vue from 'vue';

export default Vue.extend({
  props: {
    data: {
      type: Object,
      required: true,
    },
  },
});
</script>

<template>
  <SlpContainer>
    <SlpRow
      :id="data.id"
      class="overview-blocks"
      :class="`overview-blocks--${data.layout}`"
    >
      <SlpRow
        v-if="data.header && data.description"
        class="overview-blocks-header"
      >
        <SlpTypography tag="h2" variant="heading2-bold" class="slp-mb-24">
          {{ data.header }}</SlpTypography
        >
        <SlpTypography tag="p" variant="body1" class="slp-mb-48">
          {{ data.description }}</SlpTypography
        >
      </SlpRow>
      <SlpColumn v-if="data.primary" :cols="6" size="lg">
        <div
          class="primary-block card"
          :class="`primary-block card--${data.layout}`"
        >
          <SlpTypography
            tag="h2"
            :variant="
              data.layout == 'early-access' ? 'heading5-bold' : 'heading4-bold'
            "
            class="slp-mb-24"
          >
            {{ data.primary.header }}</SlpTypography
          >
          <template v-if="data.primary.list">
            <div
              v-for="item in data.primary.list"
              :key="item"
              class="slp-flex slp-pl-16 slp-pb-32"
              style="align-items: center"
            >
              <SlpIcon
                name="check"
                class="slp-mr-8"
                variant="product"
                alt="Check icon"
                size="sm"
              />
              <SlpTypography
                class="slp-pl-16"
                tag="div"
                variant="body1"
                v-html="$md.render(item)"
              >
              </SlpTypography>
            </div>
          </template>
          <SlpTypography
            v-if="data.primary?.description"
            variant="body1"
            tag="div"
            class="primary-block card-description"
            v-html="$md.render(data.primary.description)"
          />
        </div>
      </SlpColumn>
      <SlpColumn v-if="data.secondary" :cols="6" size="lg">
        <div
          class="secondary-blocks"
          :class="`secondary-blocks--${data.layout}`"
        >
          <div class="top-block card" :class="`top-block--${data.layout}`">
            <SlpTypography
              tag="h2"
              :variant="
                data.layout == 'early-access'
                  ? 'heading5-bold'
                  : 'heading4-bold'
              "
              class="slp-mb-24"
              >{{ data.secondary.header }}</SlpTypography
            >
            <template v-if="data.secondary.list">
              <div
                v-for="item in data.secondary.list"
                :key="item"
                class="slp-flex slp-pl-16 slp-pb-32"
                style="align-items: center"
              >
                <SlpIcon
                  name="check"
                  class="slp-mr-8"
                  variant="product"
                  alt="Check icon"
                  size="sm"
                />
                <SlpTypography
                  class="slp-pl-16"
                  tag="div"
                  variant="body1"
                  v-html="$md.render(item)"
                >
                </SlpTypography>
              </div>
            </template>
            <SlpTypography
              v-if="data.secondary.description"
              :variant="data.layout == 'early-access' ? 'heading5' : 'body1'"
              tag="div"
              v-html="$md.render(data.secondary.description)"
            />
          </div>
          <div
            v-if="data.cta"
            class="bottom-block"
            :class="`bottom-block--${data.layout}`"
          >
            <SlpTypography
              tag="h2"
              :variant="
                data.cta.header_typography ??
                (data.layout == 'early-access'
                  ? 'heading5-bold'
                  : 'heading4-bold')
              "
              class="slp-mb-24"
              >{{ data.cta.header }}</SlpTypography
            >
            <SlpTypography
              v-if="data.layout == 'early-access'"
              variant="heading5"
              tag="div"
              class="slp-mb-24"
              v-html="$md.render(data.cta.description)"
            />
            <SlpTypography v-else variant="body1" tag="div" class="slp-mb-24">
              {{ data.cta.description }}
            </SlpTypography>

            <SlpButton
              v-if="data.cta.link"
              :variant="data.cta.link.variant ?? 'primary'"
              :href="data.cta.link.href"
              :data-ga-name="data.cta.link.data_ga_name ?? 'Learn more'"
              :data-ga-location="data.cta.link.data_ga_location ?? 'Overview'"
            >
              {{ data.cta.link.text ?? 'Learn more' }}

              <SlpIcon
                class="slp-ml-8"
                :name="data.cta.link.icon?.name ?? 'chevron-lg-right'"
                :variant="data.cta.link.icon?.variant ?? 'product'"
                :alt="data.cta.link.icon?.alt ?? 'Chevron Right Icon'"
              />
            </SlpButton>
          </div>
        </div>
      </SlpColumn>
      <SlpRow v-if="data.subheader">
        <SlpTypography class="subheader" variant="quotes" tag="div">{{
          data.subheader
        }}</SlpTypography>
      </SlpRow>
    </SlpRow>
  </SlpContainer>
</template>

<style lang="scss" scoped>
.overview-blocks {
  @media (min-width: $breakpoint-lg) {
    margin-left: -$spacing-32;
    margin-bottom: 0;
  }
  :deep .slp-col-lg-6 {
    width: 100%;
    @media (min-width: $breakpoint-lg) {
      padding-left: $spacing-32;
    }
  }

  &--early-access {
    margin-top: 160px;
    @media (min-width: $breakpoint-lg) {
      margin-left: 0;
    }
    :deep .slp-col-lg-6 {
      @media (min-width: $breakpoint-lg) {
        padding-left: 0;
      }
    }
    .secondary-blocks {
      margin-left: $spacing-32;
      .top-block {
        padding: 40px;
      }
      .bottom-block {
        padding: 40px !important;
      }
    }
  }
  &-header {
    flex-direction: column;
  }

  .primary-block {
    height: auto;
    @media (min-width: $breakpoint-lg) {
      height: 100%;
      margin-bottom: 0;
    }
    margin-bottom: 40px;
  }
  .secondary-blocks {
    display: flex;
    flex-direction: column;
    &--early-access {
      height: 100%;
    }

    .top-block {
      margin-bottom: 40px;
      &--early-access {
        height: 50%;
      }
    }
    .bottom-block {
      background: $color-surface-900;
      padding: 40px $spacing-24;
      height: 100%;
      border: 1px solid $color-surface-200;
      border-radius: 8px;
      &--early-access {
        background: $color-primary-300;
        height: 50%;
      }
    }
  }
  :deep .slp-btn-tertiary {
    padding-left: 0;
    &:hover .slp-icon {
      transform: translateY(2px);
    }
  }
  :deep a {
    &:hover,
    &:focus,
    &:active {
      text-decoration: underline !important;
    }
  }
}
.subheader {
  font-size: 18px !important;
  margin-top: 48px;
}
.card {
  background: $color-primary-300;
  border: 1px solid $color-surface-200;
  border-radius: 8px;
  padding: $spacing-48 $spacing-24 $spacing-16 $spacing-24;
  &--early-access {
    .card-description {
      :deep p {
        line-height: 40px !important;
        padding-bottom: 12px;
        a {
          padding-right: 12px;
        }
        code {
          background: $color-surface-100;
          color: $color-text-200;
        }
      }
    }
  }
}
</style>
